.TH "cludb" "8" "Oct 2003" "" "Red Hat Cluster Manager Internal Commands"
.SH "NAME"
cludb \- Manipulate the cluster configuration directly.
.SH "WARNING"
Use of this command can cause the cluster to malfunction.  Do not run this
without instructions from Red Hat Support.
.SH "SYNOPSIS"
.B cludb
.B [\-d 
.I default
.B |\-\-default
.I default
.B ]
.B [\-f
.I filename
.B |\-\-file
.I filename
.B ]
.B [\-o
.I filename
.B |\-\-output
.I filename
.B ]
.B [\-g
.I key
.B |\-\-get
.I key 
.B ]
.B [\-p
.I key value
.B |\-\-put
.I key value
.B ]
.B [\-r
.I key
.B |\-\-remove
.I key
.B ]
.B [\-m
.I regex
.B |\-\-match
.I regex
.B ]
.B [\-x
.I regex
.B |\-\-expunge
.I regex
.B ]
.B [\-V|\-\-version]
.B [\-?|\-\-help|\-\-usage]
.SH "DESCRIPTION"
.PP 
The
.B cludb
command can be used by system administrators to insert, delete, and
manipulate tags contained within the cluster configuration.
Only one operation may occur per run.  This manipulates the cluster
configuration file,
.B /etc/cluster.xml
, as well as the view on shared storage if the cluster has a quorum.
.SH "OPTIONS"
.IP "\-d, \-\-default <default>"
Set the default for a key if there is no match found.  Use with "\-g".
.IP "\-f, \-\-file <filename>"
Use the specified filename instead of /etc/cluster.xml for input.
.IP "\-o, \-\-output <filename>"
Use the specified filename instead of /etc/cluster.xml for output.
.IP "\-g, \-\-get <key>"
Get value for specified key.
.IP "\-p, \-\-put <key> <value>"
Store the specified value in the specified key.
.IP "\-r, \-\-remove <key>"
Remove the specified key.
.IP "\-m, \-\-match <regex>"
Display all keys and values where the key matches the specified regular
expression (".*" displays all keys and values).
.IP "\-x, \-\-expunge <regex>"
Delete all keys and values matching the specified regular expression.
Dangerous.  Never do this.
.SH "CLUSTER BEHAVIORAL KEYS"
.PP
Do not maniuplate any of the following keys without instructions from
Red Hat Support.  All require a cluster-wide restart after the configuration
has propogated to ensure correct behavior.
.IP "cluster%logfacility"
This changes the logging facility the cluster uses.  See
/usr/include/sys/syslog.h for a list of valid facilities.
.IP "cluster%reboot_debug"
In some cases, clumanager will reboot a node.  Setting this flag to "yes"
will cause clumanager to write out /tmp/clumanager-reboot-debug prior
to rebooting the machine, which contains the source code file, line, and
function in the clumanager source code where the reboot was requested.
(yes/no; default=no).  If you think clumanager is rebooting your machine
without a reason, set this to "yes" and check for it on the next reboot.
You can then either browse the source file, contact Red Hat Support, or
post the relevant information to linux-cluster@redhat.com if you require
more information.  Note that this does NOT trap any reboot call initiated
from outside of clumanager, including but not limited to watchdog-initiated
reboots.
.IP "cluster%disk_error_action"
Action to take if access to the shared state information (raw devices)
returns errors (ignore/stop/halt/reboot; default=reboot).  Ignore 
the error, stop the cluster services, halt the machine immediately,
or reboot the machine immediately.
.IP "cluster%msgsvc_noarp"
If set to "yes", the cluster will no longer use an internal ARP table
for connection checks.  If you are seeing "Not in subnet" messages, try
changing this option to "yes".  Changing this requires a full restart of
the cluster software on all nodes to take effect.
.IP "clumembd%adaptive"
Toggle adaptive membership timeouts (yes/no; default=yes).  When this
is set to "yes", the cluster membership daemon will allow a grace period
for over-loaded members based on the previous amount of time between
heartbeat packets.
.IP "clumembd%interval"
Heartbeat interval, in microseconds (default=750000).  Controls the speed
by which heartbeat packets are sent. Failure detection, in seconds =
(interval * tko_count / 1000000)
.IP "clumembd%broadcast_primary_only"
If set, this causes the cluster to only send broadcast packets on the NIC
with the IP matching the member name and the loopback device.  This is only
used when using broadcast heartbeat mode, and is ignored when multicast
mode is used.
.IP "clumembd%tko_count"
Heartbeat declaration count (default=20).  Controls how many heartbeat
intervals must elapse without a heartbeat from a given member before that
member is declared out.  Failure detection, in seconds =
(interval * tko_count / 1000000)
.IP "clumembd%strict"
Toggle strict voting (yes/no; default=yes).  When this is set to "yes", the
cluster membership daemon will only vote in favor of a new membership
view if the proposed view matches its internal view.  Disabling this
causes faster membership convergence, but increases the number of
member transitions seen by the quorum daemon, service manager, and
lock manager.
.IP "clumembd%smooth"
Enable time-based smoothing (0 to tko_count-1; default=disabled).
This prevents sending new membership views to client programs until
after a time period has passed to allow for more transitions to occur.
With this enabled, membership view delivery to client programs is increased
but fewer views are sent when the cluster is unstable.
.IP "clumembd%thread"
Toggle separate transmit thread (yes/no; default=yes).  The membership 
daemon transmits and receives packets at regular intervals.  When enabled,
a thread is started which handles sending heartbeat packets.  This
thread is aware of its own speed concerning system calls and adjusts
accordingly every heartbeat interval, while the other thread handles
receipt of heartbeat packets and client requests.  Disabling this saves a
few PIDs, but slows down the membership daemon.
.IP "clumembd%rtp"
Real-Time Priority (0 to 100; default = disabled) of the cluster membership
daemon.  By default, the membership daemon does not run in real-time
priority.  You can enable this if you are having problems on heavily loaded
systems.  This value should be greater than or equal to cluquorumd%rtp.
.IP "cluquorumd%rtp"
Real-Time Priority (0 to 100; default=disabled) of the cluster quorum
daemon.  By default, the quorum daemon does not run in real-time priority.
You can enable this if you are having problems on heavily loaded systems. 
This value should be less than or equal to clumembd%rtp.
.IP "cluquorumd%disk_quorum"
Disk quorum preference (yes, no; default=no).  When using the disk
tiebreaker in 2-node clusters, this parameter controls whether or not
the disk-based heartbeating mechanism is considered an official backup
for quorum.  If set to 'yes', Cluster Manager will not attempt to
activate STONITH or fail over services if only the network connection is
lost.  Note that services may not be started/stopped/etc. manually, as
network communications are not available.
.IP "cluquorumd%allow_soft"
Soft quorum preference (yes, no; default=no).  Allows formation of a
new cluster quorum utilizing an IP tie-breaker when half of the cluster
members online.  Generally, the IP tie-breaker is only checked to maintain
quorum when half of the cluster members transition offline, not to form
a new quorum.  See 
.B
cluforce(8)
for more details.
.IP "cluquorumd%ignore_gulm"
Ignore absence of lock_gulmd (yes, no; default=no).  When using the
gulm-bridge STONITH driver, cluquorumd relies on lock_gulmd to perform and
report fencing states of cluster members.  When lock_gulmd exits on a given
member, cluquorumd shuts down Cluster Manager unless this option is set.
See
.B
lock_gulmd(8)
for more details.
.IP "clusvcmgrd%use_netlink"
If set to "yes", the cluster will use the netlink-based iproute utilities
to configure and monitor virtual IP addresses.  This works around some 
problems experienced with certain network cards when many (>4) are configured
in bonded mode.  If services are restarting because IP addresses are
"dissappearing", try enabling this option.  This option must be enabled
with all services disabled, but while all nodes are online.  IMPORTANT:
When this option is enabled, service IP addresses WILL NOT show up in the
output of the
.B
ifconfig(8)
utility.  Use "ip addr list".  See
.B
ip(8)
for more information.
.IP "clusvcmgrd%nfs_lock_workaround"
If set to "yes", the cluster software will attempt to drop NFS locks during
shutdown if a device can not be unmounted.  After doing this, it will
broadcast reclaim notifications to NLM-monitored NFS clients via all IP
addresses on the system, which will allow other NFS locks to remain in
effect.  This allows the cluster to unmount file systems during shutdown
if NFS locks are held on those file systems.  Additionally, the cluster
software will merge the NLM monitor lists from shared storage with the
machine's global monitor list during startup, drop all NFS locks, and
broadcast reclaim notifications in the same manner noted previously.
In each phase, the NFS lock grace period will be reset, and no new NFS
locks will be issued during that time (approx. 40 seconds) to any NFS
clients, irrespective of the NFS service those clients are using.  
.SH "FILES"
/etc/cluster.xml - Red Hat Cluster Manager Configuration
.SH "SEE ALSO"
clugetconfig(8), regex(3), clumembd(8), cluquorumd(8), lock_gulmd(8), ip(8),
ifconfig(8), clunfslock(8)

You can find more documentation for cluster installation and administration in 
the 
.B The Red Hat Cluster Manager Installation and Administration Guide 
located on the documentation CD\-ROM or online at http://www.redhat.com.
